module.exports = function(app, io, passport, Account, MODELCAP) {

app.route('/MODELs')
  .get(function(req, res) {
    MODELCAP.find(function(err, MODELs){
      var modelCount = MODELs.length;
      if(err) {
        res.send(err);
      } else {
        res.render('MODELs/MODELs', { 
          title: 'MODELCAPs | Mumsy',
          MODELs: MODELs,
          count: modelCount
        });
      }
    });
  })
  .post(checkLoggedIn, function(req, res) {
    Account.findById(req.user._id, function(err, account){
      if(err){
        res.send(err);
      } else {     
        var MODEL = new MODELCAP();
        MODEL._creator = req.user._id;
        MODEL.name = req.body.name;
        MODEL.content = req.body.content;
        MODEL.save(function(err) {
            if(err){
              res.send(err);
            } else {
              // account.MODELs.push(MODEL);
              // account.save(function(err) {
              //     if(err){
              //       res.send(err);
              //     } else {
              //       res.redirect('/MODELs/' + MODEL._id);            
              //     }
              // });                           
            }
        });        
      }
    });    
  });

/* GET views/new_user.hbs */
app.get('/MODELs/new', checkLoggedIn, function(req, res, next) {
  res.render('MODELs/new_MODEL', { 
    title: 'New MODELCAP | Mumsy'
  });             
});

/* GET views/user.hbs */
/* POST views/user.hbs */
app.route('/MODELs/:MODEL_id')
  .get(function(req, res) {
    MODELCAP
    .findOne({ _id: req.params.MODEL_id })
    .populate('_creator')
    .exec(function (err, MODEL) {
      if(err) {
        res.send(err);
      } else {
        var userIsOwner = false;
        if(req.user && String(req.user._id) == String(MODEL._creator._id)){
          userIsOwner = true;
        }
        res.render('MODELs/MODEL', { 
          title: 'MODELCAP Profile | Mumsy',
          MODEL: MODEL,
          isOwner: userIsOwner
        });
      }
    });    
  })
  .post(function(req, res){
    MODELCAP.findById(req.params.MODEL_id, function(err, MODEL){
      if(err) {
        res.send(err);
      } else {
        if(req.body._method == 'delete'){
          MODELCAP.remove({
              _id: req.body._id
          }, function(err, MODEL) {
              if(err) {
                req.flash('error', err);
                res.redirect('/MODELs');
              } else {
                req.flash('success', 'MODELCAP removed.');
                res.redirect('/MODELs');
            }
          }); 
        } else {        
          MODEL._creator = req.user._id;
          MODEL.name = req.body.name;
          MODEL.content = req.body.content;
          MODEL.save(function(err) {
              if(err){
                res.send(err);
              } else {
                req.flash('success', 'MODELCAP Updated.');       
                res.redirect('/MODELs/' + MODEL._id);             
              }
          });
        }          
      }
    });    
  });  

/* GET views/edit_user.hbs */
app.get('/MODELs/:MODEL_id/edit', function(req, res, next) {
    MODELCAP.findById(req.params.MODEL_id, function(err, MODEL){
      if(err) {
        res.send(err);
      } else {
        res.render('MODELs/edit_MODEL', { 
          title: 'Edit MODELCAP | Mumsy',
          MODEL: MODEL
        });             
      }
    });  
});

// route middleware to make sure a user is an admin
function checkLoggedIn(req, res, next) {

    // if user is authenticated in the session, carry on 
    if (req.isAuthenticated()) {
      next();      
    } else {
      req.flash('error', 'You need to be logged in to view this page.');       
      res.redirect('/');          
    }
}

// route middleware to make sure a user is an admin
function checkOwner(req, res, next) {

    // if user is authenticated in the session, carry on 
    if (req.isAuthenticated()) {
      MODELCAP.findById(req.params.idea_id, function(err, MODEL){
        if(err) {
          res.send(err);
        } else {
          if (String(req.user._id) == String(MODEL._creator)) {
            return next();
          } else if (req.body._method == 'comment'){
            return next();
          } else {      
            console.log('user._id: ' + req.user._id);
            console.log('MODEL._creator: ' + MODEL._creator);  
            req.flash('error', 'You need to be the correct user to view this page.');        
            res.redirect('/');  
          }         
        }
      });   
    } else {
      req.flash('error', 'You need to be logged in and the correct user to view this page.');       
      res.redirect('/');          
    }
}

};
